diff --git a/include/framework/dispatchhelper.hxx b/include/framework/dispatchhelper.hxx
index 3cca78c..b65a004 100644
--- a/include/framework/dispatchhelper.hxx
+++ b/include/framework/dispatchhelper.hxx
@@ -91,8 +91,8 @@ class FWE_DLLPUBLIC DispatchHelper : public ::cppu::WeakImplHelper< css::lang::X
         virtual css::uno::Any SAL_CALL executeDispatch(
                                         const css::uno::Reference< css::frame::XDispatchProvider >& xDispatchProvider ,
                                         const OUString&                                      sURL              ,
-                                        const OUString&                                      sTargetFrameName  ,
-                                              sal_Int32                                             nSearchFlags      ,
+                                        const OUString&                                      sRecipientFrameName  ,
+                                              sal_Int32                                             nSearchOptions      ,
                                         const css::uno::Sequence< css::beans::PropertyValue >&      lArguments        )
         throw(css::uno::RuntimeException, std::exception) override;
 
diff --git a/include/framework/menuconfiguration.hxx b/include/framework/menuconfiguration.hxx
index 3a618c2..b5db907 100644
--- a/include/framework/menuconfiguration.hxx
+++ b/include/framework/menuconfiguration.hxx
@@ -60,7 +60,7 @@ private:
 
     MenuAttributes(const OUString& rFrame, const OUString& rImageIdStr)
         : refCount(0)
-        , aTargetFrame(rFrame)
+        , aFrame(rFrame)
         , aImageId(rImageIdStr)
     {
     }
@@ -74,7 +74,7 @@ private:
     MenuAttributes(const MenuAttributes&) = delete;
 
 public:
-    OUString aTargetFrame;
+    OUString aFrame;
     OUString aImageId;
     css::uno::WeakReference<css::frame::XDispatchProvider> xDispatchProvider;
 
diff --git a/offapi/UnoApi_offapi.mk b/offapi/UnoApi_offapi.mk
index 9d44e99..d3f2327 100644
--- a/offapi/UnoApi_offapi.mk
+++ b/offapi/UnoApi_offapi.mk
@@ -2575,6 +2575,7 @@ $(eval $(call gb_UnoApi_add_idlfiles,offapi,com/sun/star/frame,\
 	FeatureStateEvent \
 	FrameAction \
 	FrameActionEvent \
+	FrameSearchOption \
 	FrameSearchFlag \
 	IllegalArgumentIOException \
 	LayoutManagerEvents \
diff --git a/offapi/com/sun/star/frame/DispatchDescriptor.idl b/offapi/com/sun/star/frame/DispatchDescriptor.idl
index eae1162..5fe3830 100644
--- a/offapi/com/sun/star/frame/DispatchDescriptor.idl
+++ b/offapi/com/sun/star/frame/DispatchDescriptor.idl
@@ -50,23 +50,23 @@ published struct DispatchDescriptor
      */
     com::sun::star::util::URL FeatureURL;
 
-    /** name of the target frame
+    /** name of the recipient frame
 
         <p>
-        Special targets (e.g. "_blank", "_self") or really existing target names can be used.
+        Special recipients (e.g. "_blank", "_self") or really existing name of recipient may be used.
         </p>
 
         @see XDispatchProvider::queryDispatch()
      */
     string FrameName;
 
-    /** describes how the target frame is to be searched
+    /** describes how the recipient frame is to be searched
 
         <p>
-        This optional parameter is used if <var>FrameName</var> isn't a special target only.
+        This optional parameter is used if <var>FrameName</var> isn't a special recipient only.
         </p>
 
-        @see FrameSearchFlag
+        @see FrameSearchOption
      */
     long SearchFlags;
 };
diff --git a/offapi/com/sun/star/frame/FrameSearchFlag.idl b/offapi/com/sun/star/frame/FrameSearchFlag.idl
index ad0a5e1..114b552 100644
--- a/offapi/com/sun/star/frame/FrameSearchFlag.idl
+++ b/offapi/com/sun/star/frame/FrameSearchFlag.idl
@@ -20,28 +20,17 @@
 #define __com_sun_star_frame_FrameSearchFlag_idl__
 
 
-
  module com {  module sun {  module star {  module frame {
 
-/** these types describe the algorithm to be used to search a frame
-
-    <p>
-    Such flags will be used on methods XFrame::findFrame(),
-    XDispatchProvider::queryDispatch() or
-    XComponentLoader::loadComponentFromURL() if no special target
-    frame name (e.g. "_blank", "_self") is used.
-    </p>
-
-    @see XFrame::findFrame()
-    @see XDispatchProvider::queryDispatch()
-    @see XComponentLoader::loadComponentFromURL()
+/*
+    it is left for backward compatibility
  */
+
 published constants FrameSearchFlag
 {
-    /** no longer supported
-
+    /**
         <p>
-        Using of this flag will do nothing. Use right combination of other flags
+        Use of this flag does nothing. Choose combination of other flags
         instead of this one.
         </p>
 
@@ -49,62 +38,17 @@ published constants FrameSearchFlag
      */
     const long AUTO = 0;
 
-    /** allows search on the parent frames
-     */
     const long PARENT = 1;
-
-    /** includes the start frame himself
-     */
     const long SELF = 2;
-
-        /** includes all child frames of the start frame
-
-            <p>
-            Note: That means all direct children and of course her children too.
-                  Search doesn't stop at the next level inside the tree!
-            </p>
-         */
     const long CHILDREN = 4;
-
-    /** frame will be created if not found
-     */
     const long CREATE = 8;
-
-        /** includes the direct siblings of the start frame
-
-            <p>
-            Normally it's interpreted as search on the direct children of the parent
-            only. But in combination with e.g. the CHILDREN flag it can include all
-            children of it too.
-            </p>
-     */
     const long SIBLINGS = 16;
-
-        /** allow the search outside the current sub task tree of the whole possible frame tree
-
-        <p>
-        If this flag isn't present, any search from bottom to top has to stop, if a top frame
-        will be reached. It doesn't influence a search from top to bottom.
-        But it can be used at the root of the frame tree to search on direct children of it only.
-        Because the direct children of the root node are the root's of the task sub trees, which
-        are top frames too. Instead of using the CHILDREN flag there, it's possible so to suppress
-        a deeper search so.
-        </p>
-     */
     const long TASKS = 32;
 
-        /** includes all frames except frames in other tasks sub trees
-        but doesn't create any new frame
-     */
     const long ALL = 23;
-
-    /** searches in the whole hierarchy of frames
-        but doesn't create any new frame
-     */
     const long GLOBAL = 55;
 };
 
-
 }; }; }; };
 
 #endif
diff --git a/offapi/com/sun/star/frame/FrameSearchOption.idl b/offapi/com/sun/star/frame/FrameSearchOption.idl
new file mode 100644
index 0000000..188c0bf
--- /dev/null
+++ b/offapi/com/sun/star/frame/FrameSearchOption.idl
@@ -0,0 +1,92 @@
+/* -*- Mode: C++; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
+/*
+ * This file is part of the LibreOffice project.
+ *
+ * This Source Code Form is subject to the terms of the Mozilla Public
+ * License, v. 2.0. If a copy of the MPL was not distributed with this
+ * file, You can obtain one at http://mozilla.org/MPL/2.0/.
+ *
+ */
+
+#ifndef __com_sun_star_frame_FrameSearchOption_idl__
+#define __com_sun_star_frame_FrameSearchOption_idl__
+
+ module com {  module sun {  module star {  module frame {
+
+/** These constants describe the algorithm to be used to search a frame
+
+    <p>
+    These options will be used with methods XFrame::findFrame(),
+    XDispatchProvider::queryDispatch() or
+    XComponentLoader::loadComponentFromURL() if no special frame name
+    e.g. "_blank", "_self" is specified.
+    </p>
+
+    @see XFrame::findFrame()
+    @see XDispatchProvider::queryDispatch()
+    @see XComponentLoader::loadComponentFromURL()
+ */
+published constants FrameSearchOption
+{
+
+    /** allows search on the parent frames
+     */
+    const long Parent = 1 << 0;
+
+    /** include the frame himself
+     */
+    const long Self = 1 << 1;
+
+        /** include all child frames
+
+            <p>
+            Note: That means all direct children and of course her children too.
+                  Search doesn't stop at the next level inside the tree
+            </p>
+         */
+    const long Children = 1 << 2;
+
+    /** frame will be created if not found
+     */
+    const long Create = 1 << 3;
+
+        /** includes the direct siblings of the frame
+
+            <p>
+            Normally it's interpreted as search on the direct children of the parent
+            only. But in combination with e.g. the Children option it can include all
+            childrens of it too.
+            </p>
+     */
+    const long Siblings = 1 << 4;
+
+        /** allow the search outside the current sub task tree of the whole possible frame tree
+
+        <p>
+        If this option isn't present, any search from bottom to top has to stop, if a top frame
+        will be reached. It doesn't influence a search from top to bottom.
+        But it can be used at the root of the frame tree to search on direct children of it only.
+        Because the direct children of the root node are the root's of the task sub trees, which
+        are top frames too. Instead of using the Children option there, it's possible to suppress
+        a deeper search.
+        </p>
+     */
+    const long Tasks = 1 << 5;
+
+        /** includes all frames except frames in other tasks sub trees
+            but doesn't create any new frame
+        */
+    const long All = Parent | Self | Children | Siblings;
+
+    /** searches in the whole hierarchy of frames but doesn't create any new frame
+     */
+    const long Global = All | Tasks;
+
+    const long FullMask = Tasks | Siblings | Create | Children | Self | Parent ;
+};
+
+}; }; }; };
+
+#endif
+
+/* vim:set shiftwidth=4 softtabstop=4 expandtab: */
